/*
 * Created on Dec 5, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package io.java;

import io.Exec;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;

import edu.caltech.sbw.Sys;

import model.Model;
import model.Parameter;
import model.Species;
/**
 * @author kmaier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class BytecodeGenerator
{
	static String line;
	private static String 	m_sTempPath = null;
	private static URL[]	m_oTempUrl 	= null;
	private static String 	m_sCompiler = null;
	private static String 	m_sCommandClassPath  = null;
	private static String 	m_sCommandBootPath  = null;
	private static String 	m_sCommandTempPath  = null;
	
	/**
	 * creates the command to compile the given file ... 
	 * the command string consists of the compiler, the classpath
	 * the bootclasspath, the filename and the directory to write to.
	 * 
	 * @param javaFile the file to be compiled
	 * @return the full command string
	 */
	public static String getCommandString(String javaFile) throws IOException
	{
		if (m_sCommandClassPath == null 
				|| m_sCommandBootPath == null 
				|| m_sCommandTempPath == null)
		{
			if (Sys.OSIsWindows())
			{
				m_sCommandBootPath = "+Z0 -bootclasspath \"" 
					+ System.getProperty("sun.boot.class.path").replaceAll(";","\";\"") 
					+ "\" ";
				m_sCommandClassPath= " -classpath \"" 
					+ System.getProperty("java.class.path").replaceAll(";","\";\"") 
					+ "\" ";
				
				m_sCommandTempPath = " -d \"" 
					+ getTempPath() + "\"";
				
			}
			else
			{
				m_sCommandBootPath = " -bootclasspath "
					+ System.getProperty("sun.boot.class.path").replaceAll(";","\";\"") + " ";

				m_sCommandClassPath= " -classpath " 
					+ System.getProperty("java.class.path").replaceAll(";","\";\"") + " ";
				
				m_sCommandTempPath = " -d " + getTempPath() ;
			}			
		}
		return getCompiler() + m_sCommandClassPath + m_sCommandBootPath + javaFile  + m_sCommandTempPath ;
	}
	/**
	 * 
	 * @return the compiler command to be used
	 */
	public static String getCompiler()
	{
		if (m_sCompiler == null)
		{
			if (Sys.OSIsWindows())
			{
				m_sCompiler = "jikes";
			}
			else
			{
				m_sCompiler = "javac";
			}			
		}
		return m_sCompiler;
	}
	/**
	 * This function gets the temp directory, verifies that the necessary
	 * files 'Evaluator.java' 'Jacob.java' and 'JacobEval.java' can be written
	 * 
	 * If these files can't be created a new temporary directory will be created. 
	 * 
	 * @return the temp path to be used 
	 * @throws IOException
	 */
	public static String getTempPath() throws IOException
	{
		if (m_sTempPath == null)
		{			
			m_sTempPath = System.getProperty("java.io.tmpdir") + java.io.File.separator;
			if (!checkTempPath())
			{
				m_sTempPath = System.getProperty("user.home") + java.io.File.separator + System.getProperty("java.io.tmpdir") + java.io.File.separator;
				try
				{
					new File(m_sTempPath).mkdirs();
					
				}
				catch (Exception e)
				{
					
				}
				if (!checkTempPath())
				{
					throw new IOException("Could not create writable temp directory.");
				}
			}
			
			
		}
		return m_sTempPath;		
	}
	
	private static boolean checkTempPath()
	{
		
		try
		{
			if ((new File (m_sTempPath + "Evaluator.java").createNewFile() 
				|| new File (m_sTempPath + "Evaluator.java").canWrite())
			&& (new File (m_sTempPath + "Evaluator.java").createNewFile() 
					|| new File (m_sTempPath + "Evaluator.java").canWrite())
			&& (new File (m_sTempPath + "Evaluator.java").createNewFile() 
					|| new File (m_sTempPath + "Evaluator.java").canWrite()))
			{
				return true;
			}
		}
		catch (Exception e)
		{
			
		}
		return false;
	}
	/**
	 * 
	 * @return a URL array with the path to the compiled files
	 */
	public static URL[] getTempURL() throws Exception
	{
		if (m_oTempUrl == null)
		{
			try
			{
			m_oTempUrl = new URL[] {new URL("file:" + getTempPath()) };
			}
			catch (MalformedURLException e)
			{
				// ignore ... can't happen
			}
		}
		return m_oTempUrl;
	}

	public static void generateEvalClass(Model model, boolean ode) throws IOException 
	{
		double t0;	
		double t1;
		deleteOldFiles("Evaluator");
		File file = new File(getTempPath() + "Evaluator.java");
		FileWriter fw = new FileWriter(file); 
	    BufferedWriter bw = new BufferedWriter(fw); 

	    line = "import io.java.EvalIF;"; 
	    bw.write(line);
	    bw.newLine();
	    
	    line = "public class Evaluator implements EvalIF{"; 
	    bw.write(line);
	    bw.newLine(); 
  	    
		writeParameters(bw, model, ode);
		
		writeGetReactionRateMethod_1(bw);
		writeGetReactionRateMethod_2(bw, model);
		writeEvalMethod(bw, model);
		writeGetPropensityMethod(bw, model);
			    	    
		//write the return statement
		line = "}"; 
		bw.write(line);
		bw.newLine();  
			    
		//close the writer
		bw.flush();
		bw.close();
		
		compile(getTempPath() +  "Evaluator.java");
	    	    	    
	    try 
		{	   
	    	URLClassLoader loader = new URLClassLoader( getTempURL());
    		EvalIF eval = ( EvalIF ) loader.loadClass ( "Evaluator").newInstance();
    		model.setEvaluator(eval); 	
		} 
	    catch (Exception e) 
		{
	    	throw new IOException("Couldn't load Evaluator class: " + e.getMessage());
		}
	}	
	
	public static void generateJacobClass(Model model, boolean ode, String[][] derivatives) throws IOException
	{
		// used for measuring the time
		double t0;	
		double t1;
		deleteOldFiles("Jacob");
		File file = new File( getTempPath() + "Jacob.java");
		FileWriter fw = new FileWriter(file); 
	    BufferedWriter bw = new BufferedWriter(fw); 

	    line = "import io.java.JacobIF;"; 
	    bw.write(line);
	    bw.newLine();

	    line = "public class Jacob implements JacobIF{"; 
	    bw.write(line);
	    bw.newLine(); 

	    writeParameters(bw, model, ode);
	    
	    writeJacob(bw, derivatives);
	    	    	    
	    //write the return statement
	    line = "}"; 
	    bw.write(line);
	    bw.newLine();  
	    	    
	    //close the writer
	    bw.flush();
	    bw.close();
	    
	    compile(getTempPath() + "Jacob.java");
	    try 
		{	   
	    	URLClassLoader loader = new URLClassLoader( getTempURL());
    		JacobIF jacob = ( JacobIF ) loader.loadClass ( "Jacob").newInstance();
    		model.setJacobian(jacob); 	
		} 
	    catch (Exception e) 
		{
			throw new IOException("Couldn't load Jacob class: " + e.getMessage() );
		}
	}
		
	public static void generateEvalAndJacobClass(Model model, boolean ode, String[][] derivatives) throws IOException
	{
		double t0;	
		double t1;
		deleteOldFiles("JacobEval");
		File file = new File(getTempPath() + "JacobEval.java");
		FileWriter fw = new FileWriter(file); 
	    BufferedWriter bw = new BufferedWriter(fw); 

	    line = "import io.java.EvalIF;"; 
	    bw.write(line);
	    bw.newLine();
	    line = "import io.java.JacobIF;"; 
	    bw.write(line);
	    bw.newLine();

	    line = "public class JacobEval implements EvalIF,JacobIF{"; 
	    bw.write(line);
	    bw.newLine(); 
	      	    
	    writeParameters(bw, model, ode);
	    
	    writeGetReactionRateMethod_1(bw);
	    writeGetReactionRateMethod_2(bw, model);
	    writeEvalMethod(bw, model);
	    writeJacob(bw, derivatives);
	    writeGetPropensityMethod(bw, model);
	    	    	    
	    //write the return statement
	    line = "}"; 
	    bw.write(line);
	    bw.newLine();  
	    	    
	    //close the writer
	    bw.flush();
	    bw.close();
	    
	    compile(getTempPath() + "JacobEval.java");
	    
	    try 
		{	   
	    	URLClassLoader 	loader 	= new URLClassLoader( getTempURL());
    		JacobIF 		jacob 	= ( JacobIF ) 	loader.loadClass ( "JacobEval" ).newInstance();
    		EvalIF 			eval 	= ( EvalIF ) 	loader.loadClass ( "JacobEval" ).newInstance();
    		model.setJacobian(jacob); 	
    		model.setEvaluator(eval); 	
		} 
	    catch (Exception e) 
		{
	    	throw new IOException("Couldn't load JacobEval class: " + e.getMessage() );		
	    }
	}
	
	private static void compile(String javaFile) throws IOException
	{
		double t0,t1;
		//compile the file
		File oTemp = new File(javaFile);
		if (!oTemp.canRead())
			throw new IOException ("File '" + javaFile + "' could not be found.");
		

		
		t0 = System.currentTimeMillis();
		
		//System.err.println("Compiling '" + javaFile + "'");
		//System.err.println("using commandline: " + getCommandString(javaFile));
		Exec.exec( getCommandString(javaFile) );
		
				
		t1 = System.currentTimeMillis();
	}
	private static void deleteOldFiles(String sFileBaseName)	
	{
		try
		{
			new File(getTempPath() + sFileBaseName + ".java").delete();
		}
		catch (Exception e)
		{
			
		}
		try
		{
			new File(getTempPath() + sFileBaseName + ".class").delete();
		}
		catch (Exception e)
		{
			
		}
	}
	private static void writeParameters(BufferedWriter bw, Model model, boolean ode) throws IOException
	{
	    // write parameters
	    for (int i = 0; i < model.getAllParameter().size(); i++) 
	    {
	    	if(model.getAllParameter().get(i) instanceof Parameter)	    	
	    		line = "double p"+i+"="+((Parameter)model.getAllParameter().get(i)).getValue()+";";
	    	else
	    		if (ode)
	    			line = "double p"+i+"="+((Species)model.getAllParameter().get(i)).getInitialConcentration()+";";
	    		else
	    			line = "double p"+i+"="+((Species)model.getAllParameter().get(i)).getInitialAmount()+";";
		    bw.write(line);
		    bw.newLine();  
		}	     
	    // write the independent Variables
	    for (int i = 0; i < model.getBoundaryTrueSpecies().length; i++) 
	    {
    		if (ode)
    			line = "double s"+i+"="+model.getBoundaryTrueSpecies()[i].getInitialConcentration()+";";
    		else
    			line = "double s"+i+"="+model.getBoundaryTrueSpecies()[i].getInitialAmount()+";";
		    bw.write(line);
		    bw.newLine(); 
		}
	    
	    //initiate the double array for the reaction formulas
	    line = "double[] reaction = new double["+model.get_javaReadableReactionRates().length+"];"; 
	    bw.write(line);
	    bw.newLine(); 	
	}
	
	private static void writeGetReactionRateMethod_1(BufferedWriter bw) throws IOException
	{
	    //write the method getReactionRate(double y[], int reaction);
	    line = "public double getReactionRate(int reac){"; 
	    bw.write(line);
	    bw.newLine();
	    
	    line = "return reaction[reac];}"; 
	    bw.write(line);
	    bw.newLine();
	}

	private static void writeGetReactionRateMethod_2(BufferedWriter bw, Model model) throws IOException
	{	    
	    line = "public double getReactionRate(int reac, double[] y){";
		bw.write(line);
		bw.newLine();  
		
	    line = "switch(reac){";
		bw.write(line);
		bw.newLine();  
		
		for (int i = 0; i < model.getReaction().length; i++) 
		{
			if (i<model.getReaction().length-1)
				line = "case "+i+": return "+model.get_javaReadableReactionRates()[i]+";";
			else
				line = "default: return "+model.get_javaReadableReactionRates()[i]+";";
			bw.write(line);
			bw.newLine();  
		}
		
	    line = "}}";
		bw.write(line);
		bw.newLine();  
	}
	private static void writeGetPropensityMethod(BufferedWriter bw, Model model) throws IOException
	{	    
	    line = "public double getPropensity(int reac, double[] y){";
		bw.write(line);
		bw.newLine();  
		
	    line = "switch(reac){";
		bw.write(line);
		bw.newLine();  
		
		for (int i = 0; i < model.getReaction().length; i++) 
		{
			if (i<model.getReaction().length-1)
				line = "case "+i+": return "+model.get_javaReadableReactionRates()[i]+";";
			else
				line = "default: return "+model.get_javaReadableReactionRates()[i]+";";
			bw.write(line);
			bw.newLine();  
		}
		
	    line = "}}";
		bw.write(line);
		bw.newLine();  
	}
	
	private static void writeEvalMethod(BufferedWriter bw, Model model) throws IOException
	{
	    //write the method eval(double[] yVals, double x)
	    line = "public double[] eval(double[] y, double x){"; 
	    bw.write(line);
	    bw.newLine(); 

	    //write the formulas
	    line = "double[] r = new double[y.length];"; 
	    bw.write(line);
	    bw.newLine();	    
	    for (int i = 0; i < model.get_javaReadableReactionRates().length; i++) 
	    {
	    	line = "reaction["+i+"]="+model.get_javaReadableReactionRates()[i]+";";
		    bw.write(line);
		    bw.newLine();  
		}
	    
	    //write the right hand side of the ODEs
	    for (int i = 0; i < model.getN().getRowDimension(); i++) 
	    {
	    	line = "r["+i+"]=0";
	    	for (int ii = 0; ii < model.getN().getColumnDimension(); ii++) 
	    		if(model.getN().get(i,ii)!=0)
	    			if(model.getN().get(i,ii)>0)
	    			{
	    				line += "+"+model.getN().get(i,ii)+"*reaction["+ii+"]"; 
	    			}
	    			else
	    			{
	    				line += model.getN().get(i,ii)+"*reaction["+ii+"]"; 
	    			}
		    line += ";";
			bw.write(line);
			bw.newLine();
		}		
	    
	    //write the return statement
	    line = "return r;}"; 
	    bw.write(line);
	    bw.newLine(); 	       
	}

	private static void writeJacob(BufferedWriter bw, String[][] derivatives) throws IOException
	{
		// write a method for each matrix-element	    
	    for (int i = 0; i < derivatives.length; i++) 
	    {
	    	for (int ii = 0; ii < derivatives[0].length; ii++) 
	    	{
	    	    //write the method get for each Matrix element
	    	    line = "public double get_"+i+"_"+ii+"(double[] y){"; 
	    	    bw.write(line);
	    	    bw.newLine(); 
	    		line = "return "+derivatives[i][ii]+";}";
			    bw.write(line);
			    bw.newLine();  
			}
		}	
		
	    //write the method eval (double[] y)
	    line = "public double[][] get_SpeciesElasticityCoefficients(double[] y){"; 
	    bw.write(line);
	    bw.newLine(); 
	    
	    //write the formulas
	    line = "double[][] r = new double["+derivatives.length+"]["+derivatives[0].length+"];"; 
	    bw.write(line);
	    bw.newLine();	    
	    for (int i = 0; i < derivatives.length; i++) 
	    {
	    	for (int ii = 0; ii < derivatives[0].length; ii++) 
	    	{
	    		line = "r["+i+"]["+ii+"]=get_"+i+"_"+ii+"(y);";
			    bw.write(line);
			    bw.newLine();  
			}
		}	

	    //write the return statement
	    line = "return r;}"; 
	    bw.write(line);
	    bw.newLine(); 	
	}	
}
