/*
 * Created on Jun 13, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package io.jni;

import math.ode.ODE;
import math.ode.ODE_Solver;

/**
 * @author fbergman
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class CVODE extends ODE_Solver {

	private ODE ode;
	    
    private native double[] cvodeCall(double[] y, double timeStart, double[] timePoints, 
    		double[] absTol, double relTol);
    
    /* (non-Javadoc)
	 * @see math.ode.ODE_Solver#solve(math.ode.ODE, double, double[], double[])
	 */
	public double[][] solve(ODE ode, double t, double[] timePoints, double[] yVals) throws Exception{
		
		double[][] result = new double[yVals.length][timePoints.length];
		
		double[] tempResult;
		try
		{
			this.ode = ode;
	    	double[] atol = new double[yVals.length];
	    	double rtol = 1.0E-6;
	
	    	for (int i = 0; i < yVals.length; i++) 
	    	{
	    		atol[i] = 1.0E-12;
			}	    		    	
	    	
	    	tempResult = cvodeCall(
					yVals, 
					t, 
					timePoints, 
					atol, 
					rtol);	    	
	    	
	    	// convert from 1d array to 2d array
	    	
			for (int y = 0; y < timePoints.length; y++)
			{
				for (int x = 1; x < yVals.length + 1; x++)
    			{
					result[x-1][y] = tempResult[(y*(yVals.length + 1) + x)]; 
    			}	    		    	    		
    		}
		}
		catch(Exception e)
		{
			throw e;
		}
		
		return result;
	}
	
	
	/**
	 * loads the lsoda library
	 */
    static 
	{
    	try
		{
    		System.loadLibrary("cvode");
		}
    	catch (Exception e)
		{
    		System.err.println ("Could not load cvode library. Make sure the library is in: " + System.getProperty("java.library.path"));
		}
    }    
    
	/**
	 * evaluates the ode-system stored in the class variable "ode" for the given "y"-values
	 * at time "t".
	 * 
	 * this method is invoked from the native side, i.e. from the original lsoda-algorithm written 
	 * in C
	 * 
	 * @param y
	 * @param t
	 * @return
	 */
	private double[] eval(double[] y, double t)
	{	
		double[] result = new double[y.length];
		double[] yVals = new double[y.length];
		System.arraycopy(y, 0, yVals, 0, yVals.length);
		
		yVals = ode.evalODE(yVals,t);
		
		System.arraycopy(yVals, 0, result, 0, yVals.length);	
		return result;				
	}

}
