/*
 * Created on Dec 3, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package math;

import java.util.StringTokenizer;

import model.Model;
import model.Species;

import org.lsmp.djep.djep.DJep;
import org.nfunk.jep.Node;
import org.nfunk.jep.ParseException;

/**
 * @author kmaier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class JacobDiff
{
	private Node[][] derivative;
	private String[][] formulas;
	private DJep[] djep;
	Species[] species;
	
	private Model model;
	
	public JacobDiff(Model model) throws ParseException
	{		
		this.model = model;
		djep = new DJep[model.getReaction().length];
		
		derivative = new Node[model.getReaction().length][model.getBoundaryFalseSpecies().length];
		formulas = new String[model.getReaction().length][model.getBoundaryFalseSpecies().length];
		String function;
		int index;
		
		for (int i = 0; i < model.getReaction().length; i++) 
		{
			djep[i] = new DJep();
			djep[i].addStandardConstants();
			djep[i].addStandardFunctions();
			djep[i].addComplex();
			djep[i].setAllowUndeclared(true);
			djep[i].setAllowAssignment(true);			
		
			for (int ii = 0; ii < model.getBoundaryFalseSpecies().length; ii++) 
			{				
				derivative[i][ii] = djep[i].parse(model.get_jepReadableReactionRates()[i]);		
				derivative[i][ii] = djep[i].differentiate(derivative[i][ii],"y"+ii);				
				derivative[i][ii] = djep[i].simplify(derivative[i][ii]);				
				formulas[i][ii] = makeJavaReadable(djep[i].getPrintVisitor().toString(derivative[i][ii]), 0);
			}			
		}		
	}
	
	private String makeJavaReadable(String function, int functionIndex)
	{
		String power = "^";
		String delim = "+-/*^()";
		String func = "";
		String closedBracket = ")";
		String openBracket = "(";
		String token;
		String base;
		String pow;
		String temp;
		StringTokenizer tok = new StringTokenizer(function, delim, true);
		int oBracketCounter;
		int cBracketCounter;
		int leftIndex;
		while(tok.hasMoreTokens())
		{				
			token = tok.nextToken().toLowerCase();
			functionIndex += token.length();
		
			if(delim.indexOf(token) >= 0) // if true => token equals +,-,*,/,(,) or ^
				if(!token.equals(power))
				{					
					if(func.length()>0)
					{
						if(func.substring(func.length()-1,func.length()).equals("+"))
						{
							if (token.equals("-"))
							{
								func = func.substring(0, func.length()-1);
//								functionIndex--;
								func += token;
							}
							else
								func += token;
						}
						else
						{
							if(func.substring(func.length()-1,func.length()).equals("-"))
							{
								if (token.equals("-"))
								{
									func = func.substring(0, func.length()-1);
//									functionIndex--;
									func += "+";
								}
								else
									func += token;
							}
							else
								func += token;
						}
					}
					else
					{
						func += token;
					}
				}
				else // token equals "^"
				{
					leftIndex = func.length();
					if (func.substring(func.length()-1, func.length()).equals(closedBracket))
					{						
						oBracketCounter = 0;						
						for (int i = func.length()-1; i > -1; i--) 
						{
							if (func.substring(i, i+1).equals(closedBracket))
								oBracketCounter++;
							else
								if (func.substring(i, i+1).equals(openBracket))
									oBracketCounter--;
							leftIndex--;								
							if (oBracketCounter == 0)
								break;
						}						
					}
					else
					{
						for (int i = func.length()-1; i > -1; i--) 
						{							
							if(delim.indexOf(func.substring(i, i+1)) >= 0)
								break;
							else
								leftIndex--;	
						}
					}
					if (function.substring(functionIndex, functionIndex+1).equals(openBracket))
					{						
						oBracketCounter = 0;	
						cBracketCounter = 0;
						for (int i = functionIndex; i < function.length(); i++) 
						{
							if (function.substring(i, i+1).equals(closedBracket))
							{
								oBracketCounter--;
								cBracketCounter++;
							}
							else
								if (function.substring(i, i+1).equals(openBracket))
									oBracketCounter++;							
							if (oBracketCounter == 0)
								break;
						}						
						pow = "";
						while(cBracketCounter>0)
						{
							token = tok.nextToken().toLowerCase();
							functionIndex += token.length();
							pow += token;							
							if (token.equals(closedBracket))
								cBracketCounter--;
						}
						pow = makeJavaReadable (pow, functionIndex);
					}
					else
					{						
						token = tok.nextToken().toLowerCase();
						functionIndex += token.length();
						pow = token;
						if (pow.equals("-"))
						{
							if (function.substring(functionIndex, functionIndex+1).equals(openBracket))
							{						
								oBracketCounter = 0;	
								cBracketCounter = 0;
								for (int i = functionIndex; i < function.length(); i++) 
								{
									if (function.substring(i, i+1).equals(closedBracket))
									{
										oBracketCounter--;
										cBracketCounter++;
									}
									else
										if (function.substring(i, i+1).equals(openBracket))
											oBracketCounter++;							
									if (oBracketCounter == 0)
										break;
								}			
								while(cBracketCounter>0)
								{
									token = tok.nextToken().toLowerCase();
									functionIndex += token.length();
									pow += token;							
									if (token.equals(closedBracket))
										cBracketCounter--;
								}
								pow = makeJavaReadable (pow, functionIndex);
							}
							else
							{
								token = tok.nextToken().toLowerCase();
								functionIndex += token.length();
								pow += token;		
//								functionIndex += token.length();
							}							
						}
						pow = makeJavaReadable (pow, functionIndex);
					}
					
					
					base = func.substring(leftIndex, func.length());
					// remove the old tokens
					func = func.substring(0, leftIndex);
					
					func += "Math.pow("+base+","+pow+")";		
				}
			else // token != delim
			{
				if(token.substring(0,1).equals("y"))
				{
					func += "y[" + token.substring(1,token.length())+"]";					
				}
				else
				{
					if (token.equals("log")
							|| token.equals("abs")
							|| token.equals("acos")
							|| token.equals("asin")
							|| token.equals("atan")
							|| token.equals("ceil")
							|| token.equals("cos")
							|| token.equals("exp")
							|| token.equals("floor")
							|| token.equals("sin")
							|| token.equals("sqrt")
							|| token.equals("tan") )
						
					{									
						func += "Math." + token;
					}
					else if (token.equals("ln") || token.equals("log10"))
					{
						func += "Math.log";
					}
					else
						func += token;
				}
			}
		}
		return func;
	}
	
	public String[][] getDerivatives() 
	{
		String[][] result = new String[derivative.length][derivative[0].length];
		for (int i = 0; i < derivative.length; i++) {
			for (int ii = 0; ii < derivative[0].length; ii++) {
				result[i][ii] = formulas[i][ii];
			}
		}
		return result;
	}
}
