/*
 * Created on 14.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package math.ode;





/**
 * @author Klaus Maier
 *
 * Abstract class which all ODE-solvers must inherit
 */
public abstract class ODE_Solver 
{
	/**
	 * must be implemented by a ode-solver
	 * @param ode
	 * @param x0
	 * @param timePoints
	 * @param yVals 
	 * @return
	 */
	public abstract double[][] solve(ODE ode, double x0, double[] timePoints, double[] yVals) throws Exception;

	/**
	 * solves the given ode;
	 * returns the values at t = xEnd;
	 */
	public double[] solve(ODE ode, double x0, double xEnd, double[] yVals) throws Exception
	{
		double[] time = new double[]{xEnd};
		double[][] tt = this.solve(ode, x0, time, yVals);
		double[] res = new double[ode.getBoundFalseSpecNum()];
		for (int i = 0; i < res.length; i++) 
		{
			res	[i] = tt[i][0];
		}
		return res;
	}
}
