/*
 * Created on Nov 24, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package math.sde.solver;

import java.math.BigDecimal;

import math.sde.Langevin_Solver;
import math.sde.SDE;

/**
 * @author kmaier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ExplicitEuler extends Langevin_Solver
{
	private double h;
	
	public ExplicitEuler(double h)
	{
		this.h = h;
	}
	
	public double[][] solve(SDE sde, double x0, double[] timePoints, double[] startVals) 
	{
		double[] oldVals = startVals;
		double[] iSpec = new double[sde.getIndSpecNum()];
		double[] dSpec = new double[sde.getDepSpecNum()];
		double[] det;
		double[] noise;
		double hSqroot;
			
		double[][] result = new double[sde.getIndSpecNum() + sde.getDepSpecNum()][timePoints.length];      	     	
		double time = x0;
		int timePointCounter = 0;      
		double oldStepSize = h;      
		int counter;
		BigDecimal aBigDecimal;

		if(x0 == timePoints[timePointCounter])
		{
			for (int i = 0; i < result.length; i++) 
			{
				result[i][0] = startVals[i];
			}
			timePointCounter++;
		}
		while (time < timePoints[timePoints.length - 1]) 
		{
			if ( (time + h) > timePoints[timePointCounter]) 
			{
				aBigDecimal = new BigDecimal(String.valueOf(timePoints[timePointCounter]));
				aBigDecimal = aBigDecimal.subtract(new BigDecimal(String.valueOf(time)));
				this.h = aBigDecimal.doubleValue();
			}     
			det = sde.evalSDE(oldVals, time);	
			noise = sde.evalNoise(oldVals, time);
			
			aBigDecimal = new BigDecimal(String.valueOf(time));
			aBigDecimal = aBigDecimal.add(new BigDecimal(String.valueOf(this.h)));      
			
			hSqroot = Math.sqrt(h);
			for (int j = 0; j < sde.getIndSpecNum(); j++) 
			{
//				oldVals[j] += hSqroot * noise[j];	
				oldVals[j] += h * det[j] + hSqroot * noise[j];		
				if (oldVals[j]<0) 
				{
					oldVals[j] = 0;
				}
				if (aBigDecimal.doubleValue() == timePoints[timePointCounter]) 
				{
					result[j][timePointCounter] = oldVals[j];					  
				}
				iSpec[j] = oldVals[j];
			}
			dSpec = sde.getDependentSpeciesValues(iSpec);
			for (int j = sde.getIndSpecNum(); j < sde.getIndSpecNum()+sde.getDepSpecNum(); j++) 
			{	
				oldVals[j] = dSpec[j-sde.getIndSpecNum()];		
				if (oldVals[j]<0) 
				{
					oldVals[j] = 0;
				}
				if (aBigDecimal.doubleValue() == timePoints[timePointCounter]) 
				{
					result[j][timePointCounter] = oldVals[j];					  
				}
			}
			if (aBigDecimal.doubleValue() == timePoints[timePointCounter]) 
			{	      
				timePointCounter++;
			}      
			time = aBigDecimal.doubleValue();
			h = oldStepSize;		  
		}			
		return result;
	}
}