/*
 * Created on Jan 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package math.sto.solver;

import math.sto.STO;
import math.sto.solver.gibson.DependencyGraph;
import math.sto.solver.gibson.IndexedPriorityQueue;

/**
 * @author kmaier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Gibson_NRM extends Gillespie 
{	
	private DependencyGraph depGraph;
	private double[] tau;
	private boolean[] isZero; // true for i if propensity a for reaction i is zero
	
	public Gibson_NRM(int seed) 
	{
		super(seed);
	}
	public Gibson_NRM() 
	{
		super();
	}
	
	public double[][] solve(STO sto, double x0, double[] timePoints, double[] yVals) 
	{		
		double[] vals = yVals;   
		int mu;
		double oldProp;
		IndexedPriorityQueue queue;
		double[][] result = new double[sto.getBoundFalseSpecNum()][timePoints.length];   	     	
		double time = x0;
		int sampleCounter = 0;  		
		
		System.arraycopy(yVals, 0, vals, 0, yVals.length);		
		
		isZero = new boolean[sto.getReactNum()];
		
		depGraph = new DependencyGraph(sto); 
		
		calcPropensities(vals, sto);  
		
		for (int i = 0; i < sto.getReactNum(); i++) 
			if(propensity[i] == 0)
			{
				isZero[i] = true;
			}
		
		calcTaus(sto.getReactNum());
		
		queue = new IndexedPriorityQueue(sto.getReactNum(), tau);		
		
		while (time < timePoints[timePoints.length - 1]) 
		{	
			time = queue.getRoot().getTau();	
//			System.out.println(time);
			mu = queue.getRoot().getReaction();
						
			vals = sto.execReaction(mu, vals);
						
			for (int i = 0; i < sto.getReactNum(); i++) 
			{				
				if (depGraph.get(mu, i) != 0)
				{
					oldProp = propensity[i];															
					
					calcPropensity(i, vals, sto);	
					
					if (propensity[i]==0)
					{							
						tau[i] = Double.POSITIVE_INFINITY;
						isZero[i] = true;
					}
					else
					{						
						if (mu != i)
						{	
							if (!isZero[i])
								tau[i] = (oldProp / propensity[i])*(tau[i] - time) + time;
							else
								tau[i] = getTau(i) + time;
						}
						else // mu == i
						{							
							tau[i] = getTau(i) + time;
						}
						isZero[i] = false;	
					}
					queue.update(i, tau[i]);
				}
			}
			while(sampleCounter < timePoints.length && time >= timePoints[sampleCounter]) 
			{
				for (int i = 0; i < result.length; i++) 
				{
					result[i][sampleCounter] = vals[i];
				}
				sampleCounter++;
			}   			
		}			
		return result;
	}
	
	private double getTau(int reaction)
	{
		double tau = -Math.log(this.random.nextDouble())/this.propensity[reaction];
		return tau;
	}

	private void calcTaus(int numReacs) 
	{
		tau = new double[numReacs];
		
		for (int i = 0; i < numReacs; i++)
		{
			tau[i] = getTau(i);	
		}
	}
}