/*
 * Created on 10.07.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package math.sto.solver;

import math.sto.STO;
import math.sto.STO_Solver;

/**
 * @author Klaus Maier
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public abstract class Gillespie extends STO_Solver 
{
	protected double[] propensity;
	protected double totPropensity;
	
	public Gillespie (int seed)
	{
		super(seed);
	}
	public Gillespie() 
	{
		super();
	}
	/**
	 * calculates the propensity for each reaction and stores it in the "propensity"-array;
	 * sums over all propensities and stores the resulting value in "totPropensity"
	 * @param vals
	 * @param sto
	 */
	protected void calcPropensities(double[] vals, STO sto)
	{		
		this.totPropensity = 0;
		this.propensity = new double[sto.getReactNum()];
		for (int i = 0; i < sto.getReactNum(); i++)
		{
			this.propensity[i] = sto.getPropensity(i, vals);
			this.totPropensity += this.propensity[i];
		}
	}
	/**
	 * calculates the propensity for each reaction and stores it in the "propensity"-array;
	 * sums over all propensities and stores the resulting value in "totPropensity"
	 * @param vals
	 * @param sto
	 */
	protected void calcPropensity(int reaction, double[] vals, STO sto)
	{		
		this.propensity[reaction] = sto.getPropensity(reaction, vals);		
	}
}
