/*
 * Created on 25.06.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package math.sto.solver;

import math.sto.STO;


/**
 * @author Klaus Maier
 *
 */
public class Gillespie_DM extends Gillespie 
{	
	public Gillespie_DM(int seed) 
	{
		super(seed);
	}
	public Gillespie_DM() 
	{
		super();
	}

	public double[][] solve( STO sto,
						double x0,
						double[] timePoints,
						double[] yVals) 
	{
		double[] vals = yVals;
		double[][] result = new double[sto.getBoundFalseSpecNum()][timePoints.length];  
		double time = x0;
		int sampleCounter = 0;  
		int reaction;
		double deltaTime;		
		System.arraycopy(yVals, 0, vals, 0, yVals.length);		
		
		while (time < timePoints[timePoints.length - 1]) 
		{	
			this.calcPropensities(vals, sto);    			          		    
			reaction = this.chooseReaction();
			deltaTime = this.chooseTime();			
			time += deltaTime;		
			while(sampleCounter < timePoints.length && time >= timePoints[sampleCounter]) 
			{	
				for (int i = 0; i < result.length; i++) 
				{
					result[i][sampleCounter] = vals[i];
				} 
				sampleCounter++;
			}   			
			vals = sto.execReaction(reaction, vals); 	  
		}			
		return result;
	}

	private int chooseReaction()
	{
		int counter = 0;
		double sumVal = this.propensity[0];
		double val = this.random.nextDouble() * this.totPropensity;
		while (sumVal < val)
		{			
			counter++;		
			sumVal += this.propensity[counter];			
		}
		return counter;
	}
	private double chooseTime()
	{
		return -Math.log(this.random.nextDouble())/this.totPropensity;
	}
}
