/*
 * Created on 03.11.2004
 *
 */
package model;


/**
 * @author Klaus Maier
 *
 * 
 * 
 */
public class KineticLaw 
{
	String timeUnits;
	String substanceUnits;
		
	Parameter[] localParameter;
	Parameter[] globalParameter;
	
	String formula;
	
	double value;  	// stores the actual value; that is the value which 
					// results from the actual parameter values and 
					// species concentrations
	

	public KineticLaw (String timeUnits,
					   String substanceUnits,
					   Parameter[] localParameter,
					   String formula)
	{		
		this.timeUnits = timeUnits;
		this.substanceUnits = substanceUnits;
		
		this.localParameter = localParameter;
		
		this.formula = deleteBlanks(formula);
	}
	
	/**
	 * @return Returns the formula.
	 */
	public String getFormula() {
		return formula;
	}

	/**
	 * @return Returns the localParameter.
	 */
	public Parameter[] getLocalParameter() {
		return localParameter;
	}

	/**
	 * @return Returns the substanceUnits.
	 */
	public String getSubstanceUnits() {
		return substanceUnits;
	}
	/**
	 * @return Returns the timeUnits.
	 */
	public String getTimeUnits() {
		return timeUnits;
	}

	/**
	 * deletes all Blanks in the given String. 
	 * This method is used because a Jep-Parser won't accept a formula with Blanks.
	 * 
	 * @param string
	 * @return
	 */
	public static String deleteBlanks(String string)
	{
		String res = "";		
		for (int i = 0; i < string.length(); i++) 
		{
			if (!string.substring(i, i+1).equals(" "))
				res += string.substring(i, i+1);
		}		
		return res;
	}
}
