/*
 * Created on 02.11.2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package model;


/**
 * @author Klaus Maier
 *
 * A species is a chemical entity that takes part in reactions
 *
 */
public class Species implements Comparable
{
	public String name; // used for a unique identifier
	String compartment;
	String units;
	
	double initialAmount;
	double initialConcentration;
//	double amount;
//	double concentration;
	
	boolean boundaryCondition;
	
	int charge;
	int specNum;
	int initialSpecNum;
//	BigInteger specNum;
//	BigInteger initialSpecNum;
	
	Compartment comp;

	public Species(String name,
				   String compartment,
				   String units,
				   double initialAmount,
				   boolean boundaryCondition,
				   int charge)
	{
		this.name = name;
		this.compartment = compartment;
		this.units = units;
		
		this.initialAmount = initialAmount;
		
		this.boundaryCondition = boundaryCondition;
		
		this.charge = charge;
	}
	public Species(String name,
			   String compartment,
			   String units,
			   double initialAmount,
			   boolean boundaryCondition,
			   int charge,
			   Compartment comp,
			   double initialConc)
{
	this.name = name;
	this.compartment = compartment;
	this.units = units;
	
	this.initialAmount = initialAmount;
	
	this.boundaryCondition = boundaryCondition;
	
	this.charge = charge;
	
	this.comp = comp;
	this.initialConcentration = initialConc;
}

	/**
	 * returns true if the id of this species-object equals the id of the
	 * AnotherSpecies-object
	 * 
	 * @param AnotherSpecies
	 * @return
	 */
	public boolean equals (Species AnotherSpecies)
	{
		if (name.equals(AnotherSpecies.name))
			return true;
		return false;
	}
	/**
	 * returns true if the id of this species-object equals the id of the
	 * AnotherSpecies-object
	 * 
	 * @param AnotherSpecies
	 * @return
	 */
	public boolean equals(String id) 
	{
		if (this.name.equals(id))
			return true;
		return false;
	}
	/**
	 * @return Returns the specNum.
	 */
	public int getSpecNum() {
		return specNum;
	}
	/**
	 * @param specNum The specNum to set.
	 */
	public void setSpecNum(int specNum) {
		this.specNum = specNum;
	}
//	/**
//	 * @param specNum The specNum to set.
//	 */
//	public void setSpecNum(BigInteger specNum) {
//		this.specNum = specNum;
//	}
//	/**
//	 * @return Returns the specNum.
//	 */
//	public BigInteger getSpecNum() {
//		return specNum;
//	}
//	/**
//	 * @return Returns the amount.
//	 */
//	public double getAmount() {
//		return amount;
//	}
//	/**
//	 * @param amount The amount to set.
//	 */
//	public void setAmount(double amount) {
//		this.amount = amount;
//	}
//	/**
//	 * @return Returns the concentration.
//	 */
//	public double getConcentration() {
//		return concentration;
//	}
//	/**
//	 * @param concentration The concentration to set.
//	 */
//	public void setConcentration(double concentration) {
//		this.concentration = concentration;
//	}
	/**
	 * @return Returns the id.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @return Returns the charge.
	 */
	public int getCharge() {
		return charge;
	}
	/**
	 * @return Returns the compartment.
	 */
	public String getCompartment() {
		return compartment;
	}
	/**
	 * @return Returns the initialAmount.
	 */
	public double getInitialAmount() {
		return initialAmount;
	}
	/**
	 * @return Returns the initialConcentration.
	 */
	public double getInitialConcentration() {
		return initialConcentration;
	}
	/**
	 * @return Returns the substanceUnits.
	 */
	public String getUnits() {
		return units;
	}
	/**
	 * @return Returns the boundaryCondition.
	 */
	public boolean isBoundaryCondition() {
		return boundaryCondition;
	}
	/**
	 * @param initialAmount The initialAmount to set.
	 */
	public void setInitialAmount(double initialAmount) {
		this.initialAmount = initialAmount;
	}
	/**
	 * @param initialConcentration The initialConcentration to set.
	 */
	public void setInitialConcentration(double initialConcentration) {
		this.initialConcentration = initialConcentration;
	}

//	/**
//	 * @return Returns the initialSpecNum.
//	 */
//	public BigInteger getInitialSpecNum() {
//		return initialSpecNum;
//	}
//	
//	/**
//	 * 
//	 * @param initialSpecNum
//	 */
//	public void setInitialSpecNum(BigInteger initialSpecNum) {
//		this.initialSpecNum = initialSpecNum;
//	}
	/**
	 * @return Returns the initialSpecNum.
	 */
	public int getInitialSpecNum() {
		return initialSpecNum;
	}
	
	/**
	 * 
	 * @param initialSpecNum
	 */
	public void setInitialSpecNum(int initialSpecNum) {
		this.initialSpecNum = initialSpecNum;
	}
	
//	/**
//	 * 
//	 * @param comp
//	 */
//	public void calcInitialSpecNum()
//	{			
//		BigDecimal dec;
//		if (!Double.isNaN(this.initialAmount))
//			if(substanceUnits.equals("moles"))
//			{
//				dec = new BigDecimal(String.valueOf(Model.AVOGADRO)).multiply(new BigDecimal(String.valueOf(this.initialAmount)));
//				this.initialSpecNum = dec.toBigInteger();
////				this.initialSpecNum = new BigInteger(String.valueOf( Model.AVOGADRO )).multiply(new BigInteger(String.valueOf(this.initialAmount))); 
////				this.initialSpecNum = (Model.AVOGADRO * this.initialAmount);
//			}
//			else // substanceUnits equals number of molecules
//				this.initialSpecNum = new BigInteger( String.valueOf( (int)this.initialAmount ));
////				this.initialSpecNum = (int)this.initialAmount;
//		else 
//		{
//			dec = new BigDecimal(String.valueOf( comp.getVolume() )).
//				multiply(new BigDecimal(String.valueOf(this.initialAmount))).
//				multiply(new BigDecimal(String.valueOf(Model.AVOGADRO)));
//			this.initialSpecNum = dec.toBigInteger();
//			
////			this.initialSpecNum = new BigInteger(String.valueOf( comp.getVolume() )).
////				multiply(new BigInteger(String.valueOf(this.initialAmount))).
////				multiply(new BigInteger(String.valueOf(Model.AVOGADRO)));
//		}
////			this.initialSpecNum = (int)(comp.getVolume() * initialConcentration * Model.AVOGADRO);	
//		
////		System.out.println(this.initialSpecNum);
//	}

	/* (non-Javadoc)
	 * @see model.Comparable#isElementOf(model.Comparable[])
	 */
	public boolean isElementOf(Comparable[] array) 
	{
		for (int i = 0; i < array.length; i++) 
		{
			if (array[i].equals(name)) 
			{
				return true;
			}
		} 
		return false;
	}

	/**
	 * returns the first Index of this Comparable in the given Array.
	 * If not Element of this array the method will return -1
	 */
	public int getIndex(Comparable[] array) 
	{
		for (int i = 0; i < array.length; i++) 
		{
			if (array[i].equals(name)) 
			{
				return i;
			}
		} 
		return -1;
	}
	/**
	 * @param comp The comp to set.
	 */
	public void setComp(Compartment comp) {
		this.comp = comp;
	}
	/**
	 * @return Returns the comp.
	 */
	public Compartment getComp() {
		return comp;
	}
	
	public Species getClone()
	{
		return new Species(this.getName(),
				this.getCompartment(),
				this.getUnits(),
				this.getInitialAmount(),
				this.isBoundaryCondition(),
				this.getCharge(),
				this.getComp(),
				this.getInitialConcentration());
	}
}
