/*
 * Created on Dec 11, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package model;

/**
 * @author kmaier
 *
 * A TMatrix contains not only double values but can also be used to update a row change in the corresponding model.
 * For instance if two rows are changed during computing the echelon-matrix, the species array has to be changed appropriately. 
 */
public interface TMatrixe 
{
	public void exchangeRows(int row, int row2);
	public void exchangeCols(int col1, int col2);
	
	public double[][] getArray();
	public double get(int row, int column);	
	public void set(int row, int column, double val);
	
	public int getColumnDimension();
	public int getRowDimension();
	
//	public void trans();
	public TMatrixe getTranspose();
	public TMatrixe getCopy();
	public TMatrixe create(int rows, int columns);
	
}
