/*
 * Created on Mar 28, 2005
 *
 */
package sim;

//import java.io.BufferedReader;
//import java.io.InputStreamReader;
//import java.util.Properties;

import edu.caltech.sbw.ModuleImpl;
import edu.caltech.sbw.SBWException;
//import edu.caltech.sbw.ModuleImpl;
//import edu.caltech.sbw.SBWException;

/**
 * @author kmaier
 *
 */
public class MainCVODE 
{

	public static void main(String[] args) 
	{		
		if (edu.caltech.sbw.Sys.OSIsMac() || edu.caltech.sbw.Sys.OSIsUnix())
        {
          System.setProperty("java.net.preferIPv4Stack", "true");
          System.setProperty("sbw.broker.allow-remote-modules", "true");
        }
		try 
		{			
			ModuleImpl moduleImp = new ModuleImpl("CVODE","Numerical Solutions to ODEs",ModuleImpl.UNIQUE);
			
			moduleImp.addService("sim",
					"Calculates deterministic time courses using CVODE",
					"plugin/simulator",
					SimulatorCVODE.class);
			
			moduleImp.run(args);
		} 
		catch (SBWException e) 
		{
			System.err.println("Error occured: " + e.getMessage() + " : " + e.getDetailedMessage());
			e.printStackTrace();
		}
		catch(Exception e)
		{
			System.err.println("Error occured: " + e.getMessage());
			e.printStackTrace();
		}
	}
}
