/*
 * Created on Mar 28, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package sim;

import edu.caltech.sbw.SBWApplicationException;

import math.sde.Langevin_Solver;
import math.sde.solver.ExplicitEuler;
import math.sde.solver.SemiImplicitEuler;

/**
 * @author kmaier
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SimulatorChemicalLangevinEquation extends SimulatorBase
{

	private double stepSize = 0.001;
	private int newtonIterations = 50;
	private double newtonTolerance = 1E-10;
	private boolean semi;	;
	
	
	public String getName()
	{
		return "Chemical Langevin Equation";
	}
	public String getVersion()
	{
		return "1.0";
	}
	public String getAuthor()
	{
		return "Klaus Maier";
	}
	public String getDescription()
	{
		return "Calculates stochastic time courses using the Chemical Langevin Equation";
	}
	public String getDisplayName()
	{
		return "Chemical_Langevin_Equation";
	}
	public String getCopyright()
	{
		return "BSD";
	}
	public String getURL()
	{
		return "www.sys-bio.org";
	}
		 		
	public double[][] simulate() throws SBWApplicationException, Exception
	{
		Langevin_Solver solver;
		if (semi)
			solver = new SemiImplicitEuler(this.stepSize, this.newtonTolerance, this.newtonIterations);
		else
			solver = new ExplicitEuler(this.stepSize);
		double[] timePoints = getTimePoints(t0,tEnd,numPoints);
		double[][] res = new double[vals.length][timePoints.length];
		res = solver.solve(model, t0, timePoints, vals);
		return mergeResults(timePoints, res);
	}
		
	
	public void setStepSize(double step)
	{
		this.stepSize = step;
	}

	public void setNumNewtonIterations(int num)
	{
		this.newtonIterations = num;
	}
	
	public void setNewtonTolerance(double tol)
	{
		this.newtonTolerance = tol;
	}
	
	public void setSemiImplicit(boolean semi)
	{
		this.semi = semi;
	}
	
}
